//
//      CppHelloWorld.cpp
//

#include <AEEStdLib.h>
#include "CppHelloWorld.hpp"

int AEEClsCreateInstance(AEECLSID ClsId, IShell* pIShell, IModule* po, void** ppObj);
static boolean CppHelloWorld_HandleEvent(CppHelloWorld* pi, AEEEvent eCode, uint16 wParam, uint32 dwParam);

//  Avbg Gg
int AEEClsCreateInstance(AEECLSID ClsId, IShell* pIShell, IModule* po, void** ppObj)
{
    *ppObj = NULL;

    if (ClsId == AEECLSID_CPPHELLOWORLD) {
        if (AEEApplet_New(sizeof(CppHelloWorld), ClsId, pIShell, po, (IApplet**)ppObj, (AEEHANDLER)CppHelloWorld_HandleEvent, NULL) == TRUE) {
            return AEE_SUCCESS;
        }
    }
    return EFAILED;
}

//  X^eBbN Cxg nh
static boolean CppHelloWorld_HandleEvent(CppHelloWorld* pi, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{
    return pi->HandleEvent(eCode, wParam, dwParam);
}

//  Cxg nh
boolean CppHelloWorld::HandleEvent(AEEEvent eCode, uint16 wParam, uint32 dwParam)
{
    boolean result = FALSE;

    switch (eCode) {
        case EVT_APP_START:
            OnAppStart((AEEAppStart*)dwParam);
            result = TRUE;
            break;
        case EVT_KEY:
            result = OnKey(wParam);
            break;
    }
    return result;
}

//  AvJnnh
void CppHelloWorld::OnAppStart(AEEAppStart* environment)
{
    static AECHAR const text[] = {'H', 'e', 'l', 'l', 'o', ' ', 'W', 'o', 'r', 'l', 'd', '\0'};

    IDISPLAY_DrawText(m_pIDisplay, AEE_FONT_NORMAL, text, -1, 0, 0, NULL, IDF_ALIGN_CENTER | IDF_ALIGN_MIDDLE | IDF_TEXT_TRANSPARENT);
    IDISPLAY_Update(m_pIDisplay);
    return;
}

//  L[ nh
boolean CppHelloWorld::OnKey(uint16 key)
{
    boolean result = FALSE;

    switch (key) {
        case AVK_SELECT:
            ISHELL_CloseApplet(m_pIShell, FALSE);
            result = TRUE;
            break;
    }
    return result;
}
